Subject: Re: bug#24510: 25.1; Info: searching for ` does not find what looks like `

From: Clément Pit--Claudel <[email-masked]>
Date: Sat, 24 Sep 2016 13:24:50 -0400

On 2016-09-24 13:08, Eli Zaretskii wrote:
>> Cc: [email-masked] From: Clément Pit--Claudel
>> <[email-masked]> Date: Sat, 24 Sep 2016 12:30:07 -0400
>> 
>> I'm not sure it makes sense to equate "better" and "worse" with
>> more or less coverage.   Is Consolas worse than Courier New in
>> terms of number of characters supported?  Certainly.  But then why
>> is Emacs not defaulting to MingLiu or NSimSun?  They are both
>> monospace, both available in recent releases of Microsoft Windows,
>> and they both cover multiple East-Asian scripts, (Courier New
>> doesn't).  On my system, MingLiu supports 28955 glyphs; over 23
>> times as many as Courier New.
> 
> Not just the number of characters matters: the number of Unicode 
> blocks also matters, maybe even more.  Each block is some script, so 
> supporting less blocks means less scripts supported by the default 
> font.  Emacs will have then look for a different font, which makes 
> less pleasant display, creates text alignment problems, etc.

Thanks for the explanation. But MingLiu supports 34 blocks, while Courier New supports 23.  In particular, MingLiu has support for traditional Chinese and Japanese Hiragana and Katakana, which Courier New lacks.

>> Do we have evidence that users of Emacs on Windows write
>> significant amounts of code in Arabic, to the point that we would
>> want to use Courier New as the default, instead of as a fallback?
>> If so, do we have evidence that more code is written in Emacs in
>> Arabic than in Chinese and Japanese?  And finally, do we have
>> evidence that users of scripts that Consolas does not support
>> prefer having Courier New as the default, rather than Consolas with
>> a fallback to Courier New, or MingLiu?
> 
> I'm not sure I understand where these questions go.  We don't have 
> evidence either way, so the issues you raise cannot help us make the 
> decision.

The question was whether we had evidence in one way, and you answered it; thanks!
I don't know about either way, though: we do have evidence that many other editors don't do the same thing as we do.

> I personally consider Consolas worse than Courier New, because 
> Consolas's coverage is clearly biased towards European scripts.

True.  But Courier is biased too.  In fact, virtually all programming fonts are biased in that way, maybe as an unfortunate artifact of most programming languages themselves being biased towards ASCII.  In selecting the default Emacs font, we're trying to ensure that users have an agreeable experience: if most of what they look at in a monospace font is covered by ASCII, then it's not clear to me that it makes sense to select a monospace font based on coverage only.

>> I'm not too familiar with editors on Windows.  Do many of them
>> default to Courier New?  AFAICT Netbeans apparently does, but Atom
>> doesn't (it uses Consolas), Visual Studio doesn't (it uses
>> Consolas), Sublime Text doesn't (it uses Consolas), Eclipse doesn't
>> (it changed from Courier New to Consolas in 2011), and Notepad++
>> doesn't (it changed from Courier New to Source Code Pro in 2015).
>> What makes things that are acceptable for so many other editors
>> non-starters for us?
> 
> One reason is that Emacs has a wider range of different
> applications, where being able to support as many languages and
> scripts as possible is more important than in Studio or even Vim.
> E.g., at least some of the editors you mention are never used as
> email/news clients or Web browsers, where the ability to support as
> many scripts as possible is important.

Do many of these applications require a monospace font?  Eww now defaults to a proportional face, doesn't it?

Clément.